{ Free Pascal }

// Today's date: 26.02.2013
// code by Tran Ha Vu
// Quick sort algorithm, Andrew's scan algorithm are used in this code
// algorithm speed - O(N^2 log N)

Program Pairs;

const RED = 1;
      BLUE = 2;

type point =    record
     x,y: integer;
     col: byte;
     num: integer;
     usd: boolean; end;

     vector = record a,b: integer; end;

     Thull = record
             up,dw: array [0..5001] of integer;
             sizeup,sizedw: integer;
             end;
     Tpair = record
             f,s: integer;  {first - red, second - blue}
             end;

//begin global variables
var f1,f2: text;
    count,blocks,n,ne: integer;
    a: array [0..5001] of point;
    hull: THull;
    pair: array [0..5001] of Tpair;
    pairnum: integer;
//end   global variables

(* SOME TRASH *)

function up(x,y,z: integer): boolean;                        //rotate right
var u,v: vector;                                      begin
u.a:=a[y].x-a[x].x;  v.a:=a[z].x-a[y].x;
u.b:=a[y].y-a[x].y;  v.b:=a[z].y-a[y].y;                     //Ua*Vb-Ub*Va -
              up:=((u.a*v.b-u.b*v.a)<0);                end; //vector multiple

function dw(x,y,z: integer): boolean;                        //rotate left
var u,v: vector;                                      begin
u.a:=a[y].x-a[x].x;  v.a:=a[z].x-a[y].x;
u.b:=a[y].y-a[x].y;  v.b:=a[z].y-a[y].y;                     //Ua*Vb-Ub*Va -
              dw:=((u.a*v.b-u.b*v.a)>0);                end; //vector multiple


procedure swap(x,y: integer);    var z: point;        begin  //just swap :D
z:=a[x]; a[x]:=a[y]; a[y]:=z;                           end;

function smaller(x,y: longint): boolean;              begin  //smaller penis
  smaller:=((a[x].x<a[y].x) or                               // MY PENIS IS BIGGER THAN YOURTH
           ((a[x].x=a[y].x) and (a[x].y<a[y].y)));      end;

procedure qsort(left,right: integer);                        //sort
var l,r,t: longint;                                   begin
l:=left;
r:=right;  t:=(l+r) div 2;
repeat while smaller(l,t) do inc(l);
       while smaller(t,r) do dec(r);
       if l<=r then begin swap(l,r); inc(l); dec(r); end;
until  l>r;
if l<right then qsort(l,right);
if left<r  then qsort(left,r);                          end;

function findtheline(left,right: integer): integer;          //vertical line
var x: integer;  s: integer;                          begin
s:=0;
x:=left;  repeat
          if (not (a[x].usd))and(a[x].col=RED)  then inc(s)
          else
          if (not (a[x].usd))and(a[x].col=BLUE) then dec(s);
          inc(x);
          until (s=0) or (x>right);
findtheline:=x-1;                                       end;

procedure checkandadd(x,y: integer);                  begin  //new pair
    if (a[x].usd) or (a[y].usd) then exit;
    if (a[x].col=RED) and (a[y].col=BLUE) then begin
    inc(pairnum);
    pair[pairnum].f:=x;  //RED   first
    pair[pairnum].s:=y;  //BLUE  second
    a[x].usd:=true;
    a[y].usd:=true;                              end else

    if (a[y].col=RED) and (a[x].col=BLUE) then begin
    inc(pairnum);
    pair[pairnum].f:=y;  //RED   first
    pair[pairnum].s:=x;  //BLUE  second
    a[y].usd:=true;
    a[x].usd:=true;                              end    end;

(* SOME TRASH *)

procedure converthull(_from,_to: integer);                   //hull convert
var size,second,j,x,y,z,start,fin: integer;
                                                      begin
hull.sizeup:=0;
hull.sizedw:=0;

start:=_from; while a[start].usd do inc(start);
fin:=  _to;   while a[fin].usd   do dec(fin);

if start>=fin then exit;

if fin-start=1 then begin hull.sizeup:=2;
                          hull.up[1]:=start;
                          hull.up[2]:=fin;
                    end;

// CHECK FOR CORRECT INPUT (from,to) VALUES

size:=2;
hull.up[1]:=start;                                           // Andrew's
second:=start+1;                                             // Algorithm
while a[second].usd do inc(second);

hull.up[2]:=second;         for j:=second+1 to fin do
                                 if not a[j].usd then begin  //creating
inc(size);  repeat                                           //upside hull
            dec(size);
            x:=hull.up[size-1];
            y:=hull.up[size];
            z:=j;
            until (size=1) or up(x,y,z);
inc(size);  hull.up[size]:=j;                           end;
hull.sizeup:=size;

size:=2;
hull.dw[1]:=start;
second:=start+1;
while a[second].usd do inc(second);

hull.dw[2]:=second;         for j:=second+1 to fin do
                                 if not a[j].usd then begin  //creating
inc(size);  repeat                                           //downside hull
            dec(size);
            x:=hull.dw[size-1];
            y:=hull.dw[size];
            z:=j;
            until (size=1) or dw(x,y,z);
inc(size);  hull.dw[size]:=j;                           end;
hull.sizedw:=size;                                      end;


function analyze(start,finish: integer): byte;

var j,middle: integer;
    pairnum0,delta,_from,_to: integer;
                                                      Begin
    pairnum0:=pairnum;   {pairnum0}
converthull(start,finish);
                         {create hull from start to finish}

if (hull.sizeup=0) and (hull.sizedw=0) then begin
                                            analyze:=0; //return 0
                                            exit;
                                            end;
if (hull.sizeup=2) and (hull.sizedw=0) then begin
                         checkandadd(hull.up[1],hull.up[2]);
                         analyze:=0;                    //return 0
                         exit;                end;

for j:=2 to hull.sizeup do
    checkandadd(hull.up[j-1],hull.up[j]);
// all points in the upside of hull that dont have same colors

for j:=2 to hull.sizedw do
    checkandadd(hull.dw[j-1],hull.dw[j]);
// all points in the downside of hull that dont have same colors
delta:=pairnum-pairnum0;

_from:=start;
_to:=finish;
while a[_from].usd do inc(_from);
while a[_to].usd   do dec(_to);

if _from>=_to then begin analyze:=0; exit end;          //return 0

{all points on the hull had the same color}
                                      if delta=0 then begin
middle:=findtheline(_from,_to);
analyze(_from,middle);
analyze(middle+1,_to);                                  end
{if some points on the hull had different colors}
                                    else analyze(_from,_to);
analyze:=0;                                             End;

var ERROR: byte;
                                                      BEGIN
assign(f1,'pairs.in');  reset(f1);        readln(f1,blocks);
assign(f2,'pairs.out'); rewrite(f2);
                            for count:=1 to blocks do BEGIN
readln(f1,n);  for ne:=1 to n do   begin
               {first - red, second - blue}
               readln(f1,a[ne].x,a[ne].y);
               a[ne].col:=RED;
               a[ne].num:=ne;
               a[ne].usd:=false;     end;
               for ne:=1 to n do        begin
               readln(f1,a[n+ne].x,a[n+ne].y);
               a[n+ne].col:=BLUE;
               a[n+ne].num:=ne;
               a[n+ne].usd:=false;        end;   pairnum:=0;
// end of reading input block;
QSORT(1,n+n);
// end of sorting A for andrew's scan
ERROR:=ANALYZE(1,n+n);
// end of analyzing N points
if pairnum=0 then writeln(f2,0) else

{first - red, second - blue}
for ne:=1 to pairnum do
writeln(f2,a[pair[ne].f].num,' ',a[pair[ne].s].num);
                                                        END;
close(f1);
close(f2);                                              END.






