/* GCC */
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct cord
{
   int X,Y,C,N,W;
};

int sqr(int x1, int y1, int x2, int y2, int x3, int y3)
{
   return (x1-x3)*(y2-y3)-(x2-x3)*(y1-y3);
}

bool cmp(cord a, cord b)
{
   if(a.X==b.X){return a.Y>b.Y;}
   else return a.X<b.X;
}

int main()
{
   int t,n,x,y,k,i,j,q,w,lu,ld,s,f,fm,brk,nl;
   cord c[5002];
   int u[10][5002],d[10][5002],l[10],wl[10],wlf[10];
   freopen("pairs.in","r",stdin);
   freopen("pairs.out","w",stdout);
   scanf("%d",&t);
   for(q=1; q<=t; q++)
   {
      scanf("%d",&n);
      for(i=0; i<2*n; i++) 
      {
         scanf("%d%d",&x,&y);
         c[i].X=x;
         c[i].Y=y;
         c[i].C=i/n;
         c[i].N=i%n+1;
         c[i].W=0;
      }
      n*=2;
      sort(c,c+n,cmp);
      k=0; w=0; i=2;
      u[0][0]=2;
      u[0][1]=0;
      u[0][2]=1;
      d[0][0]=2;
      d[0][1]=0;
      d[0][2]=1;
      f=0; fm=0;
      l[0]=1000000;
      while(k<n)
      {
         f=0;
         while(i<n)
         {
            if(c[i].W!=0){i++;continue;}
            if(c[i].X>l[f]){f++;}
            ld=d[f][0];
            lu=u[f][0];
            if(sqr(c[i].X,c[i].Y,c[u[f][lu]].X,c[u[f][lu]].Y,c[u[f][lu-1]].X,c[u[f][lu-1]].Y)<=0){u[f][0]++;u[f][u[f][0]]=i;}
            else
            {
               while(lu>1 && sqr(c[i].X,c[i].Y,c[u[f][lu]].X,c[u[f][lu]].Y,c[u[f][lu-1]].X,c[u[f][lu-1]].Y)>0) lu--;
               if(lu==1){u[f][0]=2;u[f][2]=i;}
               else
                 if(sqr(c[i].X,c[i].Y,c[u[f][lu]].X,c[u[f][lu]].Y,c[u[f][lu-1]].X,c[u[f][lu-1]].Y)<=0){u[f][0]=lu+1;u[f][u[f][0]]=i;}
                 else{u[f][0]=2;u[f][2]=i;}
            }
            if(sqr(c[i].X,c[i].Y,c[d[f][ld]].X,c[d[f][ld]].Y,c[d[f][ld-1]].X,c[d[f][ld-1]].Y)>=0){d[f][0]++;d[f][d[f][0]]=i;}
            else
            {
               while(ld>1 && sqr(c[i].X,c[i].Y,c[d[f][ld]].X,c[d[f][ld]].Y,c[d[f][ld-1]].X,c[d[f][ld-1]].Y)<0) ld--;
               if(ld==1){d[f][0]=2;d[f][2]=i;}
               else
                if(sqr(c[i].X,c[i].Y,c[d[f][ld]].X,c[d[f][ld]].Y,c[d[f][ld-1]].X,c[d[f][ld-1]].Y)>=0){d[f][0]=ld+1;d[f][d[f][0]]=i;}
                else{d[f][0]=2;d[f][2]=i;}
            }
            i++;
         }
         brk=0; nl=0;
         for(i=0; i<=fm; i++)
          if(d[i][d[i][0]-1]==u[i][u[i][0]-1] && u[i][0]>2 && d[i][0]>2){brk=1;;break;}
         if(brk==1){printf("0\n");break;}
         for(f=0; f<=fm; f++)
         {
            s=0;
            for(i=1; i<u[f][0]; i++)
             {
                if(c[u[f][i]].C!=c[u[f][i+1]].C && c[u[f][i]].W==0 && c[u[f][i+1]].W==0)
                  {s++;c[u[f][i]].W=1;c[u[f][i+1]].W=1;if(c[u[f][i]].C==0){printf("%d %d\n",c[u[f][i]].N,c[u[f][i+1]].N);}else{printf("%d $d",c[u[f][i+1]].N,c[u[f][i]].N);}}
             }
            for(i=1; i<d[f][0]; i++)
             {
                if(c[d[f][i]].C!=c[d[f][i+1]].C && c[d[f][i]].W==0 && c[d[f][i+1]].W==0)
                  {s++;c[d[f][i]].W=1;c[d[f][i+1]].W=1;if(c[d[f][i]].C==0){printf("%d %d\n",c[d[f][i]].N,c[d[f][i+1]].N);}else{printf("%d $d",c[d[f][i+1]].N,c[d[f][i]].N);}}
             }
            if(s==0){nl++; wlf[nl]=f; if(u[f][0]>2){wl[nl]=u[f][(u[f][0]+1)/2];} else {wl[nl]=d[f][(d[f][0]+1)/2];}}
            else{k+=s*2;}
         }
         if(nl>0)
         {
            for(i=1; i<=nl; i++)
            {
               for(j=fm; j>=wlf[i]+(i-1); j--)
               {
                  l[j+1]=l[j];
                  for(x=0; x<=d[j][0]; x++) {d[j+1][x]=d[j][x];u[j+1][x]=u[j][x];}
               }
               l[wlf[i]+(i-1)]=c[wl[i]].X;
               d[wlf[i]+i][0]=0;
               d[wlf[i]+i][1]=wl[i]+1;
               d[wlf[i]+i][2]=wl[i]+2;
               u[wlf[i]+i][0]=0;
               u[wlf[i]+i][1]=wl[i]+1;
               u[wlf[i]+i][2]=wl[i]+2;
            }
         }
      }
   }
}
